package persistence.test;

import java.util.Arrays;
import java.util.List;
import javax.jdo.JDOHelper;
import javax.jdo.PersistenceManager;
import javax.jdo.PersistenceManagerFactory;
import javax.jdo.Query;
import persistence.test.model.Dependent;
import persistence.test.model.Holder;

/**
 *
 * @author steve
 */
public class PersistenceTest {

    public static void persist() {
        PersistenceManagerFactory pmf = JDOHelper.getPersistenceManagerFactory("store.odb");
        PersistenceManager pm = pmf.getPersistenceManager();
        pm.currentTransaction().begin();
        Dependent dependent1 = new Dependent("d1");
        Dependent dependent2 = new Dependent("d2");
        List<Dependent> dependents = Arrays.asList(dependent1, dependent2);
        Holder holder = new Holder("h1", dependents);
        pm.makePersistent(holder);
        pm.currentTransaction().commit();
        pm.close();
        pmf.close();
    }

    public static void delete() {
        PersistenceManagerFactory pmf = JDOHelper.getPersistenceManagerFactory("store.odb");
        PersistenceManager pm = pmf.getPersistenceManager();
        pm.currentTransaction().begin();
        Query query = pm.newQuery(Holder.class);
        List<Holder> holders = (List<Holder>) query.execute();
        pm.deletePersistentAll(holders);
        query.closeAll();
        pm.currentTransaction().commit();
        pm.close();
        pmf.close();
    }
    public static void countInstances() {
        PersistenceManagerFactory pmf = JDOHelper.getPersistenceManagerFactory("store.odb");
        PersistenceManager pm = pmf.getPersistenceManager();
        Query query = pm.newQuery(Holder.class);
        List<Holder> holders = (List<Holder>) query.execute();
        System.out.println("Holders: " + holders.size());
        query.closeAll();
        query = pm.newQuery(Dependent.class);
        List<Dependent> dependents = (List<Dependent>) query.execute();
        System.out.println("Dependents: " + dependents.size());
        query.closeAll();
        pm.close();
        pmf.close();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
            persist();
            delete();
            countInstances();
    }

}
